"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.calculate = void 0;
const defaults = {
    wpm: 200,
    lessThanOne: "less than a minute",
    singular: "%{minute} minute",
    plural: "%{minute} minutes",
};
function calculate(text, options = {}) {
    const merged = Object.assign(Object.assign({}, defaults), options);
    const words = text.trim().split(/\s+/g);
    let time = words.length / merged.wpm;
    const regtoken = new RegExp("%{minute}", "gim");
    let result;
    if (time < 1)
        result = merged.lessThanOne.replace(regtoken, time.toString());
    else {
        time = Math.round(time);
        result =
            time > 1
                ? merged.plural.replace(regtoken, time.toString())
                : merged.singular.replace(regtoken, time.toString());
    }
    return result;
}
exports.calculate = calculate;
