import { expect } from "chai";
import { calculate, IReadTimeOptions } from "..";

const tests = [
	{
		text: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam rhoncus urna diam, quis ultricies nulla feugiat a. Integer felis mauris, elementum eget ornare at, gravida ac sem. Proin in nisi hendrerit augue placerat suscipit id sit amet elit. Sed id maximus risus. Aliquam laoreet, enim et bibendum varius, urna augue finibus quam, quis malesuada leo enim vel neque. Integer consequat tortor ut molestie tincidunt. Integer finibus quam quis massa aliquam, in mollis orci auctor. Morbi elementum id arcu sit amet volutpat. Integer accumsan ante vel velit malesuada consectetur. Integer condimentum gravida quam nec sagittis. Mauris porttitor justo ut risus feugiat, tempus consequat sem mattis. Donec porttitor molestie est, vitae lacinia odio mollis sit amet. Cras vitae tincidunt lorem. Donec mauris ipsum, ultrices non scelerisque at, sagittis ultrices felis. Interdum et malesuada fames ac ante ipsum primis in faucibus. Maecenas rutrum nulla ac sapien ullamcorper, a tempor mi sodales. Cras ultricies mi et velit condimentum, a venenatis lectus rhoncus. Donec maximus porttitor neque, et aliquam dui euismod sit amet. Phasellus quis velit id lectus consectetur congue. Duis non ligula diam. Nunc vel rutrum diam, eget laoreet orci. Mauris accumsan ultrices lorem non sodales. Nullam ultrices dictum enim sed facilisis. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae; Curabitur in tristique nisl. Aliquam lorem neque, facilisis eget lacus id, mollis ultricies sapien. Praesent faucibus odio vel nunc iaculis, a pharetra nulla mollis. Quisque elit eros, convallis rutrum justo eu, posuere dignissim nulla. Sed dapibus faucibus tempor. Quisque tempor, ligula vel tincidunt fermentum, ligula dolor dapibus nunc, ut gravida urna elit sed justo. Donec viverra placerat eros vel hendrerit. Duis commodo vulputate feugiat. Aenean quis nisl nec libero venenatis laoreet a ut arcu. Nam at tellus vitae elit luctus lacinia. Nulla convallis leo a elit mattis, eu vulputate ex commodo. Nunc vestibulum lobortis sapien, at mattis lacus porta vitae. Nunc vel lacus orci. Nulla bibendum finibus tempus. Duis pulvinar ante est, sed condimentum nisl semper nec. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut magna nibh, congue id quam sit amet, lobortis sodales lectus. Suspendisse molestie orci ante, nec finibus ipsum rhoncus quis. Aenean lobortis rhoncus turpis. Aenean eget dapibus sapien. Vestibulum hendrerit luctus eros, nec euismod est imperdiet et. Cras vel libero vel magna ullamcorper varius ut nec orci. Proin finibus ante non dui tincidunt, quis ultricies dolor ullamcorper.",
		result: "2 minutes",
	},
	{
		text: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam rhoncus urna diam, quis ultricies nulla feugiat a. Integer felis mauris, elementum eget ornare at, gravida ac sem. Proin in nisi hendrerit augue placerat suscipit id sit amet elit. Sed id maximus risus. Aliquam laoreet, enim et bibendum varius, urna augue finibus quam, quis malesuada leo enim vel neque. Integer consequat tortor ut molestie tincidunt. Integer finibus quam quis massa aliquam, in mollis orci auctor. Morbi elementum id arcu sit amet volutpat. Integer accumsan ante vel velit malesuada consectetur. Integer condimentum gravida quam nec sagittis. Mauris porttitor justo ut risus feugiat, tempus consequat sem mattis. Donec porttitor molestie est, vitae lacinia odio mollis sit amet. Cras vitae tincidunt lorem. Donec mauris ipsum, ultrices non scelerisque at, sagittis ultrices felis. Interdum et malesuada fames ac ante ipsum primis in faucibus. Maecenas rutrum nulla ac sapien ullamcorper, a tempor mi sodales. Cras ultricies mi et velit condimentum, a venenatis lectus rhoncus. Donec maximus porttitor neque, et aliquam dui euismod sit amet. Phasellus quis velit id lectus consectetur congue. Duis non ligula diam. Nunc vel rutrum diam, eget laoreet orci. Mauris accumsan ultrices lorem non sodales. Nullam ultrices dictum enim sed facilisis. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae; Curabitur in tristique nisl. Aliquam lorem neque, facilisis eget lacus id, mollis ultricies sapien. Praesent faucibus odio vel nunc iaculis, a pharetra nulla mollis. Quisque elit eros, convallis rutrum justo eu, posuere dignissim nulla. Sed dapibus faucibus tempor. Quisque tempor, ligula vel tincidunt fermentum, ligula dolor dapibus nunc, ut gravida urna elit sed justo. Donec viverra placerat eros vel hendrerit. Duis commodo vulputate feugiat. Aenean quis nisl nec libero venenatis laoreet a ut arcu. Nam at tellus vitae elit luctus lacinia. Nulla convallis leo a elit mattis, eu vulputate ex commodo. Nunc vestibulum lobortis sapien, at mattis lacus porta vitae. Nunc vel lacus orci. Nulla bibendum finibus tempus. Duis pulvinar ante est, sed condimentum nisl semper nec. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut magna nibh, congue id quam sit amet, lobortis sodales lectus. Suspendisse molestie orci ante, nec finibus ipsum rhoncus quis. Aenean lobortis rhoncus turpis. Aenean eget dapibus sapien. Vestibulum hendrerit luctus eros, nec euismod est imperdiet et. Cras vel libero vel magna ullamcorper varius ut nec orci. Proin finibus ante non dui tincidunt, quis ultricies dolor ullamcorper.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam rhoncus urna diam, quis ultricies nulla feugiat a. Integer felis mauris, elementum eget ornare at, gravida ac sem. Proin in nisi hendrerit augue placerat suscipit id sit amet elit. Sed id maximus risus. Aliquam laoreet, enim et bibendum varius, urna augue finibus quam, quis malesuada leo enim vel neque. Integer consequat tortor ut molestie tincidunt. Integer finibus quam quis massa aliquam, in mollis orci auctor. Morbi elementum id arcu sit amet volutpat. Integer accumsan ante vel velit malesuada consectetur. Integer condimentum gravida quam nec sagittis. Mauris porttitor justo ut risus feugiat, tempus consequat sem mattis. Donec porttitor molestie est, vitae lacinia odio mollis sit amet. Cras vitae tincidunt lorem. Donec mauris ipsum, ultrices non scelerisque at, sagittis ultrices felis. Interdum et malesuada fames ac ante ipsum primis in faucibus. Maecenas rutrum nulla ac sapien ullamcorper, a tempor mi sodales. Cras ultricies mi et velit condimentum, a venenatis lectus rhoncus. Donec maximus porttitor neque, et aliquam dui euismod sit amet. Phasellus quis velit id lectus consectetur congue. Duis non ligula diam. Nunc vel rutrum diam, eget laoreet orci. Mauris accumsan ultrices lorem non sodales. Nullam ultrices dictum enim sed facilisis. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae; Curabitur in tristique nisl. Aliquam lorem neque, facilisis eget lacus id, mollis ultricies sapien. Praesent faucibus odio vel nunc iaculis, a pharetra nulla mollis. Quisque elit eros, convallis rutrum justo eu, posuere dignissim nulla. Sed dapibus faucibus tempor. Quisque tempor, ligula vel tincidunt fermentum, ligula dolor dapibus nunc, ut gravida urna elit sed justo. Donec viverra placerat eros vel hendrerit. Duis commodo vulputate feugiat. Aenean quis nisl nec libero venenatis laoreet a ut arcu. Nam at tellus vitae elit luctus lacinia. Nulla convallis leo a elit mattis, eu vulputate ex commodo. Nunc vestibulum lobortis sapien, at mattis lacus porta vitae. Nunc vel lacus orci. Nulla bibendum finibus tempus. Duis pulvinar ante est, sed condimentum nisl semper nec. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut magna nibh, congue id quam sit amet, lobortis sodales lectus. Suspendisse molestie orci ante, nec finibus ipsum rhoncus quis. Aenean lobortis rhoncus turpis. Aenean eget dapibus sapien. Vestibulum hendrerit luctus eros, nec euismod est imperdiet et. Cras vel libero vel magna ullamcorper varius ut nec orci. Proin finibus ante non dui tincidunt, quis ultricies dolor ullamcorper.Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam rhoncus urna diam, quis ultricies nulla feugiat a. Integer felis mauris, elementum eget ornare at, gravida ac sem. Proin in nisi hendrerit augue placerat suscipit id sit amet elit. Sed id maximus risus. Aliquam laoreet, enim et bibendum varius, urna augue finibus quam, quis malesuada leo enim vel neque. Integer consequat tortor ut molestie tincidunt. Integer finibus quam quis massa aliquam, in mollis orci auctor. Morbi elementum id arcu sit amet volutpat. Integer accumsan ante vel velit malesuada consectetur. Integer condimentum gravida quam nec sagittis. Mauris porttitor justo ut risus feugiat, tempus consequat sem mattis. Donec porttitor molestie est, vitae lacinia odio mollis sit amet. Cras vitae tincidunt lorem. Donec mauris ipsum, ultrices non scelerisque at, sagittis ultrices felis. Interdum et malesuada fames ac ante ipsum primis in faucibus. Maecenas rutrum nulla ac sapien ullamcorper, a tempor mi sodales. Cras ultricies mi et velit condimentum, a venenatis lectus rhoncus. Donec maximus porttitor neque, et aliquam dui euismod sit amet. Phasellus quis velit id lectus consectetur congue. Duis non ligula diam. Nunc vel rutrum diam, eget laoreet orci. Mauris accumsan ultrices lorem non sodales. Nullam ultrices dictum enim sed facilisis. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia curae; Curabitur in tristique nisl. Aliquam lorem neque, facilisis eget lacus id, mollis ultricies sapien. Praesent faucibus odio vel nunc iaculis, a pharetra nulla mollis. Quisque elit eros, convallis rutrum justo eu, posuere dignissim nulla. Sed dapibus faucibus tempor. Quisque tempor, ligula vel tincidunt fermentum, ligula dolor dapibus nunc, ut gravida urna elit sed justo. Donec viverra placerat eros vel hendrerit. Duis commodo vulputate feugiat. Aenean quis nisl nec libero venenatis laoreet a ut arcu. Nam at tellus vitae elit luctus lacinia. Nulla convallis leo a elit mattis, eu vulputate ex commodo. Nunc vestibulum lobortis sapien, at mattis lacus porta vitae. Nunc vel lacus orci. Nulla bibendum finibus tempus. Duis pulvinar ante est, sed condimentum nisl semper nec. Lorem ipsum dolor sit amet, consectetur adipiscing elit. Ut magna nibh, congue id quam sit amet, lobortis sodales lectus. Suspendisse molestie orci ante, nec finibus ipsum rhoncus quis. Aenean lobortis rhoncus turpis. Aenean eget dapibus sapien. Vestibulum hendrerit luctus eros, nec euismod est imperdiet et. Cras vel libero vel magna ullamcorper varius ut nec orci. Proin finibus ante non dui tincidunt, quis ultricies dolor ullamcorper.",
		result: "6 minutes",
	},
	{
		text: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nam rhoncus urna diam, quis ultricies nulla feugiat a. Integer felis mauris, elementum eget ornare at, gravida ac sem. Proin in nisi hendrerit augue placerat suscipit id sit amet elit. Sed id maximus risus. Aliquam laoreet, enim et bibendum varius, urna augue finibus quam, quis malesuada leo enim vel neque. Integer consequat tortor ut molestie tincidunt. Integer finibus quam quis massa aliquam, in mollis orci auctor. Morbi elementum id arcu sit amet volutpat. Integer accumsan ante vel velit malesuada consectetur. Integer condimentum gravida quam nec sagittis.",
		result: "less than a minute",
	},
	{
		text: "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Duis facilisis augue metus, id dapibus nunc aliquet vitae. Suspendisse faucibus justo id fermentum porta. Aenean volutpat eu enim id faucibus. Sed lobortis sit amet libero sit amet tempor. Phasellus eu urna risus. Donec pulvinar elit porta, rutrum libero vitae, iaculis erat. Fusce porta quam libero, id ornare nunc iaculis in. Morbi in scelerisque magna, non condimentum quam. Etiam ullamcorper lacus vel dui lacinia, nec vehicula nunc vestibulum. In hac habitasse platea dictumst. Pellentesque maximus, nisl a congue rutrum, mauris purus dignissim diam, quis condimentum dui elit sit amet massa. Donec eleifend et felis maximus viverra. Phasellus facilisis scelerisque enim in egestas. Mauris tristique, diam porttitor imperdiet rhoncus, neque est lacinia diam, nec facilisis nibh ante quis ligula. Donec sit amet augue mi. Proin cursus tincidunt nisl, eget dictum lorem tristique a. Vivamus nec gravida tortor. Nunc pretium enim id nulla placerat bibendum. Etiam aliquam, leo sed sodales faucibus, metus metus mollis enim, ut dignissim arcu quam sit amet eros. Quisque vulputate nulla porta, consectetur dolor eu, posuere ante. Maecenas convallis diam et diam convallis molestie. Mauris sed turpis id eros facilisis auctor sed non est. Fusce finibus aliquam nisl interdum interdum.",
		result: "1 minute",
	},
];

const options: IReadTimeOptions = {
	singular: "%{minute} dakika",
	plural: "%{minute} dakika",
	lessThanOne: "bir dakikadan kısa",
};

describe("Read Time Tests", () => {
	it("Default Tests", (done) => {
		for (const test of tests) {
			const { text, result } = test;
			const calculated = calculate(text);

			expect(calculated).to.be.equal(result);
		}

		done();
	});

	it("Custom Options Tests", (done) => {
		for (const test of tests) {
			const calculated = calculate(test.text, options);

			const result = test.result
				.replace(
					/less than a minute/gim,
					"bir dakikadan kısa" as string,
				)
				.replace(/minutes/gim, "dakika" as string)
				.replace(/minute/gim, "dakika" as string);

			expect(calculated).to.be.equal(result);
		}

		done();
	});
});
